# Class: Collection

## ol.Collection

Adds methods to standard Array; changes (add/remove) to the Collection trigger events. Because a Collection is itself an `ol.Object`, it can be bound to any other Object or Collection such that a change in one will automatically be reflected in the other.

#### new ol.Collection(opt_array) experimental

src/ol/collection.js, line 80

  Name | Type | Description
  --- | --- | ---
  `array` | Array | optional Array.

  ##### Fires:

  - `add` (ol.CollectionEvent) experimental - Triggered when an item is added to the collection.
  - `beforepropertychange` (ol.ObjectEvent) experimental - Triggered before a property is changed.
  - `change:length` (ol.ObjectEvent) experimental
  - `propertychange` (ol.ObjectEvent) experimental - Triggered when a property is changed.
  - `remove` (ol.CollectionEvent) experimental - Triggered when an item is removed from the collection.

### Extends

- ol.Object

### Observable Properties

Name | Type | Settable | ol.ObjectEvent type | Description
--- | --- | --- | --- | ---
`length` | number | no | `change:length` | The length of the array.

### Methods

#### bindTo(key, target, opt_targetKey){ol.ObjectAccessor} inherited experimental

src/ol/object.js, line 257

  The bindTo method allows you to set up a two-way binding between a `source` and `target` object. The method returns an ol.ObjectAccessor with a transform method that lets you transform values on the way from the source to the target and on the way back.

  For example, if you had two map views (sourceView and targetView) and you wanted the target view to have double the resolution of the source view, you could transform the resolution on the way to and from the target with the following:

      sourceView.bindTo('resolution', targetView)
        .transform(
          function(sourceResolution) {
            // from sourceView.resolution to targetView.resolution
            return 2 * sourceResolution;
          },
          function(targetResolution) {
            // from targetView.resolution to sourceView.resolution
            return targetResolution / 2;
          }
        );

  Name | Type | Description
  --- | --- | ---
  `key` | string | Key name.
  `target` | ol.Object | Target.
  `targetKey` | string | optional Target key.

#### clear() experimental

src/ol/collection.js, line 100

  Remove all elements from the collection.

#### dispatchChangeEvent() inherited experimental

src/ol/observable.js, line 41

  Dispatches a `change` event.

  ##### Fires:

  - `change` experimental

#### extend(arr){ol.Collection} experimental

src/ol/collection.js, line 112

  Name | Type | Description
  --- | --- | ---
  `arr` | Array | Array.

  ##### Returns:

  This collection.

#### forEach(f, opt_this) experimental

src/ol/collection.js, line 130

  Iterate over each element, calling the provided callback.

  Name | Type | Description
  --- | --- | ---
  `f` | function | The function to call for every element. This function takes 3 arguments (the element, the index and the array). The return value is ignored.
  `this` | S | optional The object to use as `this` in `f`.

#### get(key){*} inherited experimental

src/ol/object.js, line 314

  Gets a value.

  Name | Type | Description
  --- | --- | ---
  `key` | string | Key name.

  ##### Returns:

  Value.

#### getArray(){Array} experimental

src/ol/collection.js, line 143

  Get a reference to the underlying Array object. Warning: if the array is mutated, no events will be dispatched by the collection, and the collection's "length" property won't be in sync with the actual length of the array.

  ##### Returns:

  Array.

#### getKeys(){Array.<string>} inherited experimental

src/ol/object.js, line 342

  Get a list of object property names.

  ##### Returns:

  List of property names.

#### getLength(){number} experimental

src/ol/collection.js, line 165

  Get the length of this collection.

  ##### Returns:

  The length of the array.

#### getProperties(){Object.<string, *>} inherited experimental

src/ol/object.js, line 374

  Get an object of all property names and values.

  ##### Returns:

  Object.

#### insertAt(index, elem) experimental

src/ol/collection.js, line 176

  Insert an element at the provided index.

  Name | Type | Description
  --- | --- | ---
  `index` | number | Index.
  `elem` | * | Element.

#### item(index){*}

src/ol/collection.js, line 154

  Get the element at the provided index.

  Name | Type | Description
  --- | --- | ---
  `index` | number | Index.

  ##### Returns:

  Element.

#### notify(key) inherited experimental

src/ol/object.js, line 394

  Notify all observers of a change on this property. This notifies both objects that are bound to the object's property as well as the object that it is bound to.

  Name | Type | Description
  --- | --- | ---
  `key` | string | Key name.

#### on(type, listener, opt_this){goog.events.Key} inherited experimental

src/ol/observable.js, line 63

  Listen for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

  ##### Returns:

  Unique key for the listener.

#### once(type, listener, opt_this){goog.events.Key} inherited experimental

src/ol/observable.js, line 76

  Listen once for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

  ##### Returns:

  Unique key for the listener.

#### pop(){*} experimental

src/ol/collection.js, line 189

  Remove the last element of the collection.

  ##### Returns:

  Element.

#### push(elem){number} experimental

src/ol/collection.js, line 200

  Insert the provided element at the end of the collection.

  Name | Type | Description
  --- | --- | ---
  `elem` | * | Element.

  ##### Returns:

  Length.

#### remove(elem){*} experimental

src/ol/collection.js, line 213

  Removes the first occurence of elem from the collection.

  Name | Type | Description
  --- | --- | ---
  `elem` | * | Element.

  ##### Returns:

  The removed element or undefined if elem was not found.

#### removeAt(index){*} experimental

src/ol/collection.js, line 231

  Remove the element at the provided index.

  Name | Type | Description
  --- | --- | ---
  `index` | number | Index.

  ##### Returns:

  Value.

#### set(key, value) inherited experimental

src/ol/object.js, line 425

  Sets a value.

  Name | Type | Description
  --- | --- | ---
  `key` | string | Key name.
  `value` | * | Value.

#### setAt(index, elem) experimental

src/ol/collection.js, line 247

  Set the element at the provided index.

  Name | Type | Description
  --- | --- | ---
  `index` | number | Index.
  `elem` | * | Element.

#### setValues(values) inherited experimental

src/ol/object.js, line 454

  Sets a collection of key-value pairs.

  Name | Type | Description
  --- | --- | ---
  `values` | Object.<string, *> | Values.

#### un(type, listener, opt_this) inherited experimental

src/ol/observable.js, line 88

  Unlisten for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

#### unbind(key) inherited experimental

src/ol/object.js, line 468

  Removes a binding. Unbinding will set the unbound property to the current value. The object will not be notified, as the value has not changed.

  Name | Type | Description
  --- | --- | ---
  `key` | string | Key name.

#### unbindAll() inherited experimental

src/ol/object.js, line 492

  Removes all bindings.

#### unByKey(key) inherited experimental

src/ol/observable.js, line 98

  Removes an event listener using the key returned by `on()` or `once()`.

  Name | Type | Description
  --- | --- | ---
  `key` | goog.events.Key | Key.